FreeMat

- Main Page
- Related Pages

ROOTS Find Roots of Polynomial

Section: Optimization and Curve Fitting

# Usage

The `roots` routine will return a column vector containing the roots of a polynomial. The general syntax is

       z = roots(p)

where `p` is a vector containing the coefficients of the polynomial ordered in descending powers.

# Internals

Given a vector

which describes a polynomial

we construct the companion matrix (which has a characteristic polynomial matching the polynomial described by `p`), and then find the eigenvalues of it (which are the roots of its characteristic polynomial), and which are also the roots of the polynomial of interest. This technique for finding the roots is described in the help page for `roots` on the Mathworks website.

# Example

Here is an example of finding the roots to the polynomial

    --> roots([1 -6 -72 -27])

    ans =
       12.1229
       -5.7345
       -0.3884